
//#include <SPI.h>
//#include <Wire.h>
//#include <Adafruit_GFX.h>
//#include <Adafruit_SSD1306.h>

//#define OLED_RESET LED_BUILTIN  //4
//Adafruit_SSD1306 display(OLED_RESET);


int row = 80;
int car_speed;



//////////////////////////////////////////////////////////////////////////////
/////////////////////////SERIAL_COM_VARIABEL/////////////////////////////////

#define DEBUG 1
const int instCount = 2;
const char instName[instCount] = { 'R', 'S'};  // R = RPM  S = SPEED  the rest later
const char kEOL = '#';
const int kMaxCharCount = 5;
int defaultValue[instCount] = {0, 0};
int currentInst;
int valueCharCount = 0;
enum TPortState { psReadInst, psReadValue };
TPortState currentState = psReadInst;

int actValue[2] = {0, 0};

int first = 0;
int DIR_Motor = 6;
int STEP_Motor = 7;
int EN_Motor = 8;

int Motor_RPM_Target = 0;
int Motor_RPM_Pos = 0;

int Motor_Speed = 200;
int Gab = 0;

unsigned long lastmillis;
unsigned long current;

void setup()

{
 // display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
//  display.clearDisplay();
  Serial.begin(115200);
  pinMode(DIR_Motor, OUTPUT);
  pinMode(STEP_Motor, OUTPUT);
  pinMode(EN_Motor, OUTPUT);
  digitalWrite(EN_Motor, LOW);
  // digitalWrite(STEP_Motor, LOW);
}

void loop()
{


 
  car_speed = actValue[1];

  // SETPPER MOTOR 26 degree pro 1000 RPM with 1/16 STEP resolution
  Motor_RPM_Target = actValue[0];
  Motor_RPM_Target = map(Motor_RPM_Target, 0, 10000, 0, 2300);



  if (car_speed < 100) {
    row = 56;
  }  if (car_speed < 10) {
    row = 80;
  }  if (car_speed > 99) {
    row = 32;
  }



  //////////////MOTOR RPM
  Gab = Motor_RPM_Target - Motor_RPM_Pos;
  Gab = abs(Gab);
  if (Gab < 150) {
    Motor_Speed = 700;
  } else {
    Motor_Speed = 200;
  }

  if (Motor_RPM_Pos < Motor_RPM_Target) {
    digitalWrite(STEP_Motor, HIGH);
    digitalWrite(STEP_Motor, LOW);
    digitalWrite(DIR_Motor, LOW);
    Motor_RPM_Pos = Motor_RPM_Pos + 1;
    delayMicroseconds(Motor_Speed);
  }
  if (Motor_RPM_Pos > Motor_RPM_Target) {
    digitalWrite(STEP_Motor, HIGH);
    digitalWrite(STEP_Motor, LOW);
    digitalWrite(DIR_Motor, HIGH);
    Motor_RPM_Pos =  Motor_RPM_Pos - 1;
    delayMicroseconds(Motor_Speed);
  }


}







////READ SERIAL
void serialEvent() {
  char tmpChar;
  int tmpValue;

  while (Serial.available()) {
    // if we're waiting for a Axis name, grab it here
    if (currentState == psReadInst) {
      tmpChar = Serial.read();

#ifdef DEBUG
      //   Serial.print("Motor: ");
      //  Serial.println(tmpChar);
#endif
      for (int i = 0; i < instCount; i++) {    // look for our axis in the array of axis names we set up
        if (tmpChar == instName[i]) {
          currentInst = i;                            // remember which axis we found
          currentState = psReadValue;                 // start looking for the Axis position
          defaultValue[currentInst] = 0;              // initialise the new position
          valueCharCount = 0;                         // initialise number of value chars read in
          break;
        }
      }
    }

    // if we're ready to read in the current Axis position data
    if (currentState == psReadValue) {
      while ((valueCharCount < kMaxCharCount) && Serial.available()) {
        tmpValue = Serial.read();
        if (tmpValue != kEOL) {
          tmpValue = tmpValue - 48;
          if ((tmpValue < 0) || (tmpValue > 9)) tmpValue = 0;
          defaultValue[currentInst] = defaultValue[currentInst] * 10 + tmpValue;
          valueCharCount++;
        }
        else break;
      }

      // if we've read the value delimiter, update the Axis and start looking for the next Axis name
      if (tmpValue == kEOL || valueCharCount == kMaxCharCount) {
#ifdef DEBUG
        //  Serial.print("Position: ");
        //   Serial.println(defaultValue[currentInst]);
        actValue[currentInst] = defaultValue[currentInst];

#endif

        currentState = psReadInst;
      }
    }
  }
}




